
; Updated!

.686
.model flat,stdcall
option casemap:none
assume fs:nothing
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
; my other useful stuff
include stdlib.inc
includelib stdlib.lib
include consolelib.inc
includelib consolelib.lib
;--------------------
; beta test version
include bignum.inc        
includelib bignum.lib    
; bn in memory:
; SIZE,SIGN,LSD...MSD
; 0x1FFFFFFFF would be
; dd 2,0,0FFFFFFFFh,1
;--------------------

.code

;a simple proc to print to stdout
printbn proc bn:dword
LOCAL bnhex[400h]:byte
	invoke bn2Hex,bn,addr bnhex
	invoke Writeln,addr bnhex
	ret
printbn endp

.data
plain db 'secret message.',0

.code

ConMain proc
LOCAL p,q,n,e,d,phi,m,ct,z,x,y,a; everything is dword :))
	pushad
	invoke bnInit,512
	; memory allocated is 4*512 bits because of montgomery (1 extra bit) 
	bnCreateX p,q,n,e,phi,d,m,ct,z; neat macro
	; generated with tE's rsa tool (yes rsaprimegen not implemented yet)
	invoke Hex2bn,T('CEE31F06C0C0724AAD36BD6C7233B6A8B2C1154D028AE2333C2E2D7F2CFEC593'),p
	invoke Hex2bn,T('985582B7432F297C0D36CAFA7D7A69E8894EB13A8B41A763F903D3B50C730B13'),q
	invoke Write,T('p: ')
	invoke printbn,p
	invoke Write,T('q: ')
	invoke printbn,q
	invoke bnMul,p,q,n;n=p*q
	invoke bnDec,p;(p-1)
	invoke bnDec,q;(q-1)
	invoke bnMul,p,q,phi
	invoke Write,T('n: ')
	invoke printbn,n; print modulus
	invoke bnMovzx,e,10001h; public exponent
	invoke bnModInv,e,phi,d; d = e^-1 mod (p-1)(q-1)
	invoke Write,T('d: ')
	invoke printbn,d; print private exp.
	invoke Writeln,addr plain; our message
	invoke Bytes2bnEx,addr plain,sizeof plain,m,0; put into bn (bswaped)
	invoke Write,T('m: ')
	invoke printbn,m; message in hex
	invoke bnMontyModExp,m,d,n,ct; ct = m^d mod n
	invoke Write,T('ct: ') 
	invoke printbn,ct; print ciphered text
	invoke bnMontyModExp,ct,e,n,z; z = ct^e mod n
	invoke Write,T('m: ')
	invoke printbn,z
	invoke bn2BytesEx,z,addr plain
	invoke Writeln,addr plain; decrypt ok?
	bnDestroyX
	invoke Getch
	popad
	ret
ConMain endp

start:
	invoke InitConsole
	invoke ConMain
	invoke ExitProcess,eax
end start
